wicked-ethtool(8)

NAME
wicked ethtool command permits to query/configure parameters of NIC and it's device driver.

SYNOPSIS
wicked ethtool <interface> < --action [ arguments ] >

NOTATION
We use the terms NIC, interface, device and tx/rx queue in a dedicated way. A device or NIC is always a piece of hardware representing a network interface, a PCI or PCMCIA card or a USB device. An interface then is the name of the network interface it gets from the kernel, when the device has been registered. A queue is typically implemented as a first-in, first-out (FIFO) ring buffer. Network device use transmit or receive queue (tx/rx queue) for storing/buffering network packet data

DESCRIPTION
wicked ethtool can be used to configure a NIC as well as to query NIC related parameters like speed, link status, driver info and various other. wicked ethtool doesn't require any file or a dbus server running which is suitable for dracut environment. Note, that the behavior depends on the effective kernel driver implementing an ethtool option. Some drivers may ignore the requested option, e.g. specified advertise modes for autonegotiation.

ACTION

The following are the ethtool actions

--get-driver-info
    Query an interface for driver information

--get-private-flags
    Query private flags of an interface defined by its device driver.

--get-link-detected
    Query the link carrier detection status

--get-link-settings
    Query ethernet card properties such as speed, autoneg, transceiver, port, supported and advertising link modes.

--get-features|--get-offload
    Query status of NIC protocol offload and other features.

--get-wake-on-lan|--get-wol
    Query wake-on-lan settings.

--get-eee
    Query NIC support of Energy-Efficient Ethernet as per IEEE 802.3az specifications.

--get-ring
    Query NIC driver's rx/tx queue size.

--get-channels
    Query NIC's multi-queue settings.

--get-coalesce
    Query interrupt rate information for a NIC.

--set-priv-flags <priv-flags> <on|off>
    Enable/disable private flags defined by the NIC driver.
        #wicked ethtool eth0 --set-priv-flags disable-tpe-recovery on
    	Note: Private flags are NIC driver specific, The flag in the example above
    	tested on Emulex OneConnect NIC

--set-link-settings <setting-name> <value>
    Configure NIC's link related settings.

    autoneg <on|off>
        Enable or disable autonegotiation. With disabled autonegotiation,
        the speed and duplex can be used to set a fixed link mode.
        With enabled autonegotiation, the speed and duplex are read-only and
        the advertise parameter can be used to specify an explicit set of
        supported modes to advertise. Alternatively, wicked can create the
        advertise set using speed and duplex to filter known supported modes.
        To disable autonegotiation and use a fixed link mode:
        # wicked ethtool eth0 --set-link-settings autoneg off speed 1000 duplex full
        To enable autonegotiation and limit/filter advertised modes by speed and duplex:
        # wicked ethtool eth0 --set-link-settings autoneg on speed 1000 duplex full

    advertise <mode,...>
        Set a specific set of comma separated speed modes to advertise in autonegotiation:
        # wicked ethtool eth0 --set-link-settings autoneg on advertise 100baseT-Half,100baseT-Full
        or as hex number list or bitmask, e.g. for modes without a known name:
        # wicked ethtool eth0 --set-link-settings autoneg on advertise 0x60000,0x800000
        To query the list of supported mode names for a specific interface, use:
        # wicked ethtool eth0 --get-link-setting

    speed <N>
        Set a fixed link speed in Mb/s while disabled autonegotiation or limit/filter
        supported autonegotiation advertise modes by desired speed and duplex.

    duplex <half|full>
        Set a fixed duplex mode while disabled autonegotiation or limit/filter
        supported autonegotiation advertise modes by desired speed and duplex.

    port <TP|AUI|BNC|MII|DA|Fibre|Other>
        Set port type of the NIC:
        # wicked ethtool eth0 --set-link-settings speed port TP

    mdix <mdi|mdi-x|auto-mdi|auto-mdi-x>
        Set mdi type for a port:
            #wicked ethtool eth1 --set-link-settings mdix auto-mdi-x

    phy-address <0-255>
        Configure MDIO address of PHY:
            #wicked ethtool eth0 --set-link-settings phy-address 0

    transceiver <internal|external>
        Configure transceiver type:
            #wicked ethtool eth0 --set-link-settings transceiver internal

--set-features <feature-name on|off>
    Enable or disable device specific protocol offload and feature settings:
        #wicked ethtool eth0 --set-features rx-gro on

--set-eee
    Configure eee related settings:

    eee <on|off>
        Enable/disable eee settings:
            #wicked ethtool eth0 --set-eee eee on

    tx-lpi <on|off>
        Configure tx low power idle settings:
            #wicked ethtool eth0 --set-eee tx-lpi on

    tx-timer <N>
        Set interface(in microseconds) delays prior to asserting its tx lpi:
            #wicked ethtool eth0 --set-eee tx-timer 100

    advertise <mode,...>
        Configure speeds for which the device should advertise EEE capabilities:
            #wicked ethtool eth0 --set-eee advertise 100baseT-Half,100baseT-Full

--set-channels <rx|tx|other|combined> <N>
    Configure rx/tx queue use by the NIC:
        #wicked ethtool eth0 --set-channels combined 4

--set-ring <rx|tx|rx-jumbo|rx-mini> <N>
    Configure rx/tx queue size use by the NIC:
        #wicked ethtool eth0 --set-ring rx 2

--set-coalesce <coalesce-name> <on|off|N>
    Configure interrupts rate settings of NIC:
        #wicked ethtool eth0 --set-coalesce rx-usecs 10
        #wicked ethtool eth0 --set-coalesce  adaptive-rx on

--set-wol
    Configure wake-on-lan settings:

    options <list of options with or without comma-separated >
            #wicked ethtool eth1 --set-wol options pumba
            #wicked ethtool eth1 --set-wol options p,u,m,b,a
            #wicked ethtool eth0 --set-wol options phy,unicast,multicast,broadcast,magic

    sopass <a colon-separated bytes in hex>
        Set the SecureOn™ password:
            #wicked ethtool eth0 --set-wol sopass 02:42:ca:66:ce:a8

COPYRIGHT
Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.

BUGS
Please report bugs at <https://bugzilla.novell.com/index.cgi>

AUTHORS
Nirmoy Das

SEE ALSO
ifcfg(5), routes(5), wicked(8), ifcfg-wireless(5), ifcfg-tunnel(5), ifcfg-vlan(5), ifcfg-bonding(5),